unit StrToken;
(* StrToken ؂o *)

interface

uses SysUtils, Classes;
(*
  @jbgdl
  ֐̌RevƂ̂́ASē֐̓t(̍Ōォ)s܂B

*)
type TSequenceCharactors = set of Char;
  function PickToken(var AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickTokenRev(var AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickToken(var AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickTokenRev(var AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickConstToken(const AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickConstTokenRev(const AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickConstToken(const AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String; overload;
  function PickConstTokenRev(const AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String; overload;

  function PickWhileSequence(var AString: String; Sequence: TSequenceCharactors): String;
  function PickWhileSequenceRev(var AString: String; Sequence: TSequenceCharactors): String;
  function PickNotWhileSequence(var AString: String; Sequence: TSequenceCharactors): String;
  function PickNotWhileSequenceRev(var AString: String; Sequence: TSequenceCharactors): String;
const
  SequencesAlpha = ['a' .. 'z', 'A' .. 'Z'];
  SequencesDigit = ['0' .. '9'];
  SequencesWords = ['a' .. 'z', 'A' .. 'Z', '0' .. '9', '_'];
implementation

{
  @񒆂̍ŏ̃g[N؂oĕԂ܂B
  AStringɂ͑ΏۂƂȂ镶wA֐Eo؂o폜񂪓܂
  Delimiterɂ́Ag[N̋؂ƂȂ镶w肵܂B
  Delimiter񒆂ɂꍇ́A܂ł̕
  Ȃꍇ́ASԂAAStrinĝ܂ł̕폜܂B
}
function PickToken(var AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String;
var i, l : Integer;
begin
  i := 1;
  l := Length(AString);
  while i < l do begin
    if AString[i] in EscapeSequence then // ̓GXP[vV[PX(̕XLbv)
      Inc(i)
    else if (ByteType(AString, i) = mbSingleByte) and
      (AString[i] = Delimiter) then // ̓f~^(g[N؂oċA)
      break;
    Inc(i);
  end;
  if (i = l) and not((ByteType(AString, i) = mbSingleByte) and
      (AString[i] = Delimiter)) then
    Inc(i);
  Result := Copy(AString, 1, i - 1);
  Delete(AString, 1, i);
end;

// Rev

function PickTokenRev(var AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String;
var i, l : Integer;
begin
  i := Length(AString);
  l := i;
  while i > 0 do begin
    if (i > 1) and (AString[i - 1] in EscapeSequence) then
      // ̓GXP[vV[PX(̕XLbv)
      Dec(i)
    else if (ByteType(AString, i) = mbSingleByte) and
      (AString[i] = Delimiter) then // ̓f~^(g[N؂oċA)
      break;
    Dec(i);
  end;
  Result := Copy(AString, i + 1, l);
  if i = 0 then
    Delete(AString, 1, l)
  else
    Delete(AString, i, l);
end;


{
  @PickTokenDelimitero[WłB
  񂪈ꕶ̎́ACharłg悤ɂĂB
  StringłgƁAg[Nʒu܂B
  (ꕶĂȂƎv镶ϐgƂɂ́AStrł͂Ȃ Str[1]ƂȂ)
}
function PickToken(var AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String;
var
  i, l, tl : Integer;
  dFirstType: TMbcsByteType;
begin
  dFirstType := ByteType(Delimiter, 1);
  i := 1;
  l := Length(AString);
  tl:= Length(Delimiter);
  while i < l do begin
    if AString[i] in EscapeSequence then // ̓GXP[vV[PX
      Inc(i)
    else if (AString[i] = Delimiter[1]) and
      (ByteType(AString, i) = dFirstType) and
      (CompareStr(Copy(AString, i, tl), Delimiter) = 0) then
      break;
    Inc(i);
  end;
  if i = l then
    Inc(i);
  Result := Copy(AString, 1, i - tl + 1);
  Delete(AString, 1, i + tl - 1);
end;

// Rev

function PickTokenRev(var AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String;
var i, l, tl : Integer;
begin
  i := Length(AString);
  l := i;
  tl:= Length(Delimiter);
  while i > 0  do begin
    if (i > tl) and (AString[i - tl] in EscapeSequence) then
      // ̓GXP[vV[PX(̕XLbv)
      Dec(i)
    else if (AString[i] = Delimiter[1]) and
        (CompareStr(Copy(AString, i, tl), Delimiter) = 0) then begin
      Result := Copy(AString, i + tl, l);
      Delete(AString, i, l);
      exit;
    end;
    Dec(i);
  end;
  Result := Copy(AString, 1, l);
  Delete(AString, 1, l);
end;

{ 萔o[W }

function PickConstToken(const AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String;
var s: String;
begin
  s := AString;
  Result := PickToken(s, Delimiter, EscapeSequence);
end;

// Rev

function PickConstTokenRev(const AString: String; Delimiter: Char; EscapeSequence: TSequenceCharactors = []): String;
var s: String;
begin
  s := AString;
  Result := PickTokenRev(s, Delimiter, EscapeSequence);
end;

function PickConstToken(const AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String;
var s: String;
begin
  s := AString;
  Result := PickToken(s, Delimiter, EscapeSequence);
end;

// Rev

function PickConstTokenRev(const AString: String; Delimiter: String; EscapeSequence: TSequenceCharactors = []): String;
var s: String;
begin
  s := AString;
  Result := PickTokenRev(s, Delimiter, EscapeSequence);
end;

////////////////////////////////////////////////////////////////////////////////

{
  @w肵ŴɊ܂܂镶ȊO̕ł܂ł؂ĕԂ܂B
  AStringɂ͑ΏۂƂȂ镶wA֐Eo؂o폜񂪓܂
  SequenceɕŴw肵܂B
}
function PickWhileSequence(var AString: String; Sequence: TSequenceCharactors): String;
var i, l : Integer;
begin
  i := 1;
  l := Length(AString);
  while i < l do begin
    if (ByteType(AString, i) <> mbSingleByte) or
      (AString[i] in Sequence) then Inc(i)
      else break;
  end;
  Result := Copy(AString, 1, i - 1);
  Delete(AString,1, i - 1);
end;

// Rev.

function PickWhileSequenceRev(var AString: String; Sequence: TSequenceCharactors): String;
var i, l : Integer;
begin
  i := Length(AString);
  l := i;
  while i > 0 do
    if (ByteType(AString, i) = mbSingleByte) and
      (AString[i] in Sequence) then Dec(i)
      else break;
  Result := Copy(AString, i + 1, l);
  Delete(AString, i + 1, l);
end;


{
  @PickWhileSequence̋tŁA̕킪oI܂B
  AStringɂ͑ΏۂƂȂ镶wA֐Eo؂o폜񂪓܂
  SequenceɕŴw肵܂B
}

function PickNotWhileSequence(var AString: String; Sequence: TSequenceCharactors): String;
var i, l : Integer;
begin
  i := 1;
  l := Length(AString);
  while i < l do
    if not( (ByteType(AString, i) = mbSingleByte) and
      (AString[i] in Sequence)) then Inc(i)
      else break;
  Result := Copy(AString, 1, i - 1);
  Delete(AString,1, i - 1);
end;

// Rev.

function PickNotWhileSequenceRev(var AString: String; Sequence: TSequenceCharactors): String;
var i, l : Integer;
begin
  i := Length(AString);
  l := i;
  while i > 0 do
    if not( (ByteType(AString, i) = mbSingleByte) and
      (AString[i] in Sequence)) then Dec(i)
      else break;
  Result := Copy(AString, i + 1, l);
  Delete(AString, i + 1, l);
end;

end.
