unit TCalHookMain;

interface
uses
  Windows, Messages;
function WHKeyboard(nCode: integer;
    wParam : WPARAM;  lParam : LPARAM) : LRESULT; stdcall;
function SetHookProcedure(Owner: HWND): Boolean; stdcall;
function UnSetHookProcedure(): Boolean; stdcall;

implementation
type
  THookShareData  = record
    OwnerWindow : HWND;
    HookWnd     : HHOOK;
  end;
  PHookShareData  = ^THookShareData;
var
  hFileMap  : THandle;
const
  HM_KEYBOARDACTION = WM_APP + $100;
  HM_KEYHOOKDONE    = WM_APP + $101;
  FileMapName       = 'Chie TCal Hook Procedure Shared Memory';

// }bvt@C̑
/// }bvht@C̑Jn
/// AccessType ANZX̌`BOpenFileMappingdwDesiredAccess̒l
/// WndMemory ̃nhϐB
/// Map }bvht@C̓e
procedure InitFileMapData(AccessType: Cardinal;
  out WndMemory: THandle; out Map: PHookShareData);
begin
  // }bvI[v
  WndMemory := OpenFileMapping(AccessType, false, FileMapName);
  if WndMemory <> 0 then // r[擾
    Map := MapViewOfFile(WndMemory, AccessType, 0, 0, 0);
end;

/// }bvht@C̑I

/// WndMemory 郁}bvht@C̃nh
/// Map 郁}bvht@C𑀍삷邽߂̃|C^
procedure FinalFileMapData(WndMemory: THandle; Map: Pointer);
begin
  UnmapViewOfFile(Map);
  CloseHandle(WndMemory);
end;

/// tbNvV[W
function WHKeyboard(nCode: integer;
    wParam : WPARAM;  lParam : LPARAM) : LRESULT; stdcall;
var
  wm: THandle;
  map: PHookShareData;
begin
  InitFileMapData(FILE_MAP_READ, wm, map);
  if nCode = HC_ACTION then
    PostMessage(map^.OwnerWindow, HM_KEYBOARDACTION,
      wParam, lParam);
  Result := CallNextHookEx(map^.HookWnd, nCode, wParam, lParam);
  FinalFileMapData(wm, map);
end;

// GNX|[g֐
/// vV[WZbg
/// OwnercCAvP[ṼEBhEnh(΂RecreateWndȂƁI)
/// ResultcTrue
function SetHookProcedure(Owner: HWND): Boolean; stdcall;
var
  wm  : THandle;
  map : PHookShareData;
begin
  InitFileMapData(FILE_MAP_WRITE, wm, map);
  map^.OwnerWindow  := Owner;
  map^.HookWnd      := SetWindowsHookEx(WH_KEYBOARD,
      WHKeyboard, HInstance, 0);
  Result            := map.HookWnd <> 0;
  if Result then
    PostMessage(map.OwnerWindow, HM_KEYHOOKDONE, 1, 0);
  FinalFileMapData(wm, map);
end;

/// vV[W
/// ResultcTrue
function UnSetHookProcedure(): Boolean; stdcall;
var
  wm  : THandle;
  map : PHookShareData;
begin
  InitFileMapData(FILE_MAP_READ, wm, map);
  Result := UnhookWindowsHookEx(map.HookWnd);
  if Result then
    PostMessage(map.OwnerWindow, HM_KEYHOOKDONE, 0, 0);
  FinalFileMapData(wm, map);
end;

initialization
  hFileMap := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE,
    0, SizeOf(THookShareData), FileMapName);
finalization
  if hFileMap <> 0 then CloseHandle(hFileMap);

end.
